# Create product charge definitions Bulk creates product charge definitions for a charge. You can create up to 1000 product charge definitions at a given time for a specific charge. In the request, you must specify the unique ID or number of the charge for which this charge definition is to be created. The ID or number of a product rate plan is optional. Note: This operation requires the Attribute-based Pricing feature to be enabled, which is in the Early Adopter phase. Endpoint: POST /v1/product-charge-definitions/bulk Version: 2026-02-20 Security: bearerAuth ## Header parameters: - `Idempotency-Key` (string) Specify a unique idempotency key if you want to perform an idempotent POST or PATCH request. Do not use this header in other request types. With this header specified, the Zuora server can identify subsequent retries of the same request using this value, which prevents the same operation from being performed multiple times by accident. - `Accept-Encoding` (string) Include the Accept-Encoding: gzip header to compress responses as a gzipped file. It can significantly reduce the bandwidth required for a response. If specified, Zuora automatically compresses responses that contain over 1000 bytes of data, and the response contains a Content-Encoding header with the compression algorithm so that your client can decompress it. - `Content-Encoding` (string) Include the Content-Encoding: gzip header to compress a request. With this header specified, you should upload a gzipped file for the request payload instead of sending the JSON payload. - `Zuora-Track-Id` (string) A custom identifier for tracing the API call. If you set a value for this header, Zuora returns the same value in the response headers. This header enables you to associate your system process identifiers with Zuora API calls, to assist with troubleshooting in the event of an issue. The value of this field must use the US-ASCII character set and must not include any of the following characters: colon (:), semicolon (;), double quote ("), and quote ('). - `Zuora-Entity-Ids` (string) An entity ID. If you have Zuora Multi-entity enabled and the OAuth token is valid for more than one entity, you must use this header to specify which entity to perform the operation in. If the OAuth token is only valid for a single entity, or you do not have Zuora Multi-entity enabled, you should not set this header. - `Zuora-Version` (string) The minor API version. For a list of available minor versions, see API upgrades. ## Request fields (application/json): - `productChargeDefinitions` (array) Container for the array of product charge definition. Example: [{"productRatePlanChargeId":"edcab92612893256dce329d0b377000e","effectiveStartDate":"2024-01-01 00:00:00","effectiveEndDate":"2025-01-01 00:00:00","listPriceBase":"Per_Billing_Period","prices":[{"currency":"USD","price":18}]}] - `productChargeDefinitions.billingPeriod` (string) The billing period for the product charge definition. - `productChargeDefinitions.billingTiming` (string) The billing timing setting for the product charge definition. Enum: "IN_ADVANCE", "IN_ARREARS" - `productChargeDefinitions.chargeModel` (string) Determines how to calculate charges. Charge models must be individually activated in Zuora Billing administration. Enum: "DiscountFixedAmount", "DiscountPercentage", "FlatFee", "PerUnit", "Tiered", "Volume", "Delivery" - `productChargeDefinitions.defaultQuantity` (number,null) The default quantity. This field is applicable only for one-time and recurring charges. - `productChargeDefinitions.effectiveEndDate` (string) The effective end date of the product charge definition. Example: "2025-01-01 00:00:00" - `productChargeDefinitions.effectiveStartDate` (string) The effective start date of the product charge definition. Example: "2024-01-01 00:00:00" - `productChargeDefinitions.listPriceBase` (string) The list price base. This field is applicable only for recurring charges. Note: The Per_Year enum value is available only if you have the Annual List Price feature enabled. Enum: "Per_Billing_Period", "Per_Month", "Per_Week", "Per_Year" - `productChargeDefinitions.prices` (array) Container for the prices of the product charge definition. Example: [{"currency":"USD","price":12}] - `productChargeDefinitions.prices.currency` (string) The currency for the price. - `productChargeDefinitions.prices.discountAmount` (number) The specific amount for a fixed discount. The field is applicable only for charges based on the Discount-Fixed Amount charge model. - `productChargeDefinitions.prices.discountPercentage` (number) The percentage of discount for a percentage discount. The field is applicable only for charges based on the Discount-Percentage charge model. - `productChargeDefinitions.prices.price` (number) The price of this item. This field is only applicable for charges based on the following charge models: - Flat Fee - Per Unit - Delivery Pricing - `productChargeDefinitions.prices.tiers` (array) Container for the tiers of the price item. This field is only applicable for charges based on the following charge models: - Tiered Pricing - Volume Pricing You must specify all relevant fields of all tiers, including pricing information for each currency. For each currency, ensure that the tiers appear in ascending order of StartingUnit. For example: [ { "startingUnit": "1", "endingUnit": "150", "currency": "USD", "price": 1.95, "priceFormat": "Per Unit" }, { "startingUnit": "151", "endingUnit": "300", "currency": "USD", "price": 1.45, "priceFormat": "Per Unit" }, { "startingUnit": "1", "endingUnit": "150", "currency": "EUR", "price": 1.75, "priceFormat": "Per Unit" }, { "startingUnit": "151", "endingUnit": "300", "currency": "EUR", "price": 1.30, "priceFormat": "Per Unit" } ] - `productChargeDefinitions.prices.tiers.currency` (string) The code corresponding to the currency for the tier's price. - `productChargeDefinitions.prices.tiers.endingUnit` (number) The end number of a range of units for the tier. This field is required for charges based on the Tiered Pricing or Tiered with Overage Pricing charge model. - `productChargeDefinitions.prices.tiers.price` (number) The price of the tier if the price format is flat fee, or the price of each unit in the tier if the price format is per unit. - `productChargeDefinitions.prices.tiers.priceFormat` (string) The price format of the tier. Enum: "Flat Fee", "Per Unit" - `productChargeDefinitions.prices.tiers.startingUnit` (number) The starting number of a range of units for the tier. This field is required for charges based on the Tiered Pricing or Tiered with Overage Pricing charge model. - `productChargeDefinitions.productRatePlanChargeId` (string) The unique ID of the charge of the charge definition. Example: "edcab92612893256dce329d0b377000e" - `productChargeDefinitions.productRatePlanChargeNumber` (string) The unique number (natural key) of the charge of the charge definition. - `productChargeDefinitions.productRatePlanId` (string) The unique ID of the product rate plan that uses this charge definition. - `productChargeDefinitions.productRatePlanNumber` (string) The unique number (natural key) of the product rate plan that uses this charge definition. - `productChargeDefinitions.specificBillingPeriod` (number,null) The specific number of billing periods for the product charge definition. - `productChargeDefinitions.specificListPriceBase` (integer,null) The number of months for the list price base of the charge definition. This field is null if the listPriceBase field is not set to Per_Specific_Months. - `productChargeDefinitions.taxCode` (string) Specifies the tax code for taxation rules. This field is required when the Taxable field is set to True. Note: This value affects the tax calculation of the charge. - `productChargeDefinitions.taxMode` (string,null) Determines how to define taxation for the charge. This field is required when the Taxable field is set to True. Note: This value affects the tax calculation of the charge. Enum: "TaxExclusive", "TaxInclusive", null - `productChargeDefinitions.taxable` (boolean) Determines whether the charge definition is taxable. When this field is set to True, the TaxMode and TaxCode fields are required. Character limit: 5 Values: True, False Note: This value affects the tax calculation of the charge. - `productChargeDefinitions.term` (number,null) The number of periods of a termed subscription that is eligible for this charge definition. This field is applicable when the termType field is set to TERMED, and is to be used together with the termPeriodType field. - `productChargeDefinitions.termPeriodType` (string,null) Specifies the period type for the subscription term that is eligible for this charge definition. Enum: "Month", "Year", "Day", "Week", null - `productChargeDefinitions.termType` (string,null) The type of the subscription that is eligible for this charge definition. Enum: "TERMED", "EVERGREEN", null - `productChargeDefinitions.uom` (string,null) Describes the unit of measure (UOM) configured in Settings > Billing for the charge. ## Response 200 fields (application/json): - `summary` (object) Summary of the results of the bulk operation. - `summary.successCount` (integer) The number of product charge definitions successfully created. - `summary.failureCount` (integer) The number of product charge definitions that are not created. - `summary.failures` (array) An array containing the index of each failed charge definition. Each index is zero-based, and refers to the position of the invalid product charge definition in the bulk payload. - `results` (array) The list of newly created product charge definitions or errors. - `results.success` (boolean) Indicates whether the charge definition is successfully created. - `results.chargeDefinitionId` (string) The unique ID of the product charge definition. This value is available only if this product charge definition is successfully created. - `results.chargeDefinitionNumber` (string) The unique number (natural key) of the product charge definition. This value is available only if this product charge definition is successfully created. - `results.processId` (string) The ID of the process that handles the operation. This value is available only if this product charge definition is not created. - `results.reasons` (array) Array of data containing the error code and reasons for failure. This value is available only if this product charge definition is not created. - `results.reasons.message` (string) Message explaining the reason for the error. - `results.reasons.code` (string) Specifies the error code associated with the error. Example: "400" - `success` (boolean) Indicates whether the request succeeded. ## Response 500 fields (application/json): - `reasons` (array) Example: [{"code":"ObjectNotFound","message":"Notification definition with id 6e569e1e05f040eda51a927b140c0ac1 does not exist"}] - `reasons.code` (string) The error code of response. - `reasons.message` (string) The detail information of the error response ## Response 4XX fields (application/json): - `processId` (string) The ID of the process that handles the operation. - `reasons` (array) The container of the error code and message. This field is available only if the success field is false. - `reasons.code` (string) The error code of response. - `reasons.message` (string) The detail information of the error response - `requestId` (string) Unique identifier of the request. - `success` (boolean) Indicates whether the call succeeded.